Index: FOIAVistA/tag/r/RADIOLOGY_NUCLEAR_MEDICINE-RA/RAHLTCPB.m
===================================================================
--- FOIAVistA/trunk/r/RADIOLOGY_NUCLEAR_MEDICINE-RA/RAHLTCPB.m	(revision 631)
+++ FOIAVistA/tag/r/RADIOLOGY_NUCLEAR_MEDICINE-RA/RAHLTCPB.m	(revision 636)
@@ -1,18 +1,10 @@
 RAHLTCPB ; HIRMFO/REL,GJC,BNT,PAV - Rad/Nuc Med HL7 TCP/IP Bridge;05/21/99
- ;;5.0;Radiology/Nuclear Medicine;**12,17,25,51,71,81,84**;Mar 16, 1998;Build 13
+ ;;5.0;Radiology/Nuclear Medicine;**12,17,25,51,71,81**;Mar 16, 1998;Build 12
  ; 07/05/2006 BAY/KAM Remedy Call 124379 Eliminate unneeded ORM msgs
- ; 09/01/2006   Acomodate multiple ORC/OBR segments Patch 81
- ; 
- ;Integration Agreements
- ;----------------------
- ;INIT^HLFNC2(2161); GENACK^HLMA1(2165); $$DT^XLFDT(10103)
- ; 
+ ; 09/01/2006   Acomodate multiplr ORC/OBR segments Patch 81
 EN1 ; Build the ^TMP("RARPT-REC" global when we receive the
  ; 07/05/2006 Remedy Call 124379 message from HL7. If RAHLTCPB is defined, do not broadcast ORM messages. As of the writing
- ; of patch 71, RAHLTCPB is referenced in RAHLTCPB, UPSTAT^RAUTL0, & UP2^RAUTL1 Generic provider: RADIOLOGY,OUTSIDE SERVICE
- N RATELE,RATELENM,RATELEPI,RATELEKN,RATELEDR,RATELEDF
- D TELE^RAHLRPTT ;Patch 84
- ;** branch to new HL7 logic when the HL7 version surpasses 2.3 **
- I HL("VER")>2.3,($T(^RAHLTCPX))'="" GOTO EN1^RAHLTCPX
+ ; of patch 71, RAHLTCPB is referenced in RAHLTCPB, UPSTAT^RAUTL0, & UP2^RAUTL1
+ ;G:$G(HL("VER"))]"2.3" EN1^RAHLTCPX
  S RASUB=HL("MID"),RAHLTCPB=1 K RAERR
  ;**********************************************
@@ -68,9 +60,7 @@
  . S:$P(RADTCN,$E(HL("ECH")),2)]"" ^TMP(RARRR,$J,RASUB,"RALONGCN")=$P(RADTCN,$E(HL("ECH")),2)
  . Q
- I $G(RADTI)'>0 S RAERR="Invalid exam registration timestamp" D XIT Q
- I $G(RACNI)'>0 S RAERR="Invalid exam record IEN" D XIT Q
  S RAHLD=$$PCEXTR^RAHLO4(CNT,SEGMNT,25,HL("FS")) K RAHL70
  I RAHLD="" S RAERR="Missing Report Status" D XIT Q
- I "AFR"'[RAHLD S RAERR="Invalid Report Status: "_RAHLD D XIT Q
+ I "AFR"'[RAHLD S RAERR="Invalid Report Status" D XIT Q
  S ^TMP(RARRR,$J,RASUB,"RASTAT")=RAHLD
  G:$P(RARRR,"-",3) 112 S RAHLD=$$PCEXTR^RAHLO4(CNT,SEGMNT,32,HL("FS")) K RAHL70
@@ -82,5 +72,5 @@
  E  D  ; $D(^VA(200,"B",RAVERF)) true, get the entry ien
  . S RAVERF=$O(^VA(200,"B",RAVERF,0))
- . S:'RAVERF RAERR="Invalid Provider Name: "_RAHLD
+ . S:'RAVERF RAERR="Invalid Provider Name"
  ; can't get resident info from medspeak
  S RAHLD=$$PCEXTR^RAHLO4(CNT,SEGMNT,33,HL("FS")),RARSDNT="" K RAHL70
@@ -96,5 +86,4 @@
  I $D(RAERR) D XIT Q
  D ESIG^RAHLO3
- ;
  ;If last OBR set provider info to all OBRs
  K XX F I=1:1:RACN S XX=RARRR_"-"_I D:$D(^TMP(XX,$J,RASUB))
@@ -110,5 +99,5 @@
  . Q:SEGMNT?@("1"""_HL("FS")_"""."""_HL("FS")_"""")  ;Quit if OBX is something as:    OBX||||||||
  . I $P(SEGMNT,HL("FS"),3)']"" S RAERR="Missing Observation Identifier" Q
- . S OBXTYP=$P($P(SEGMNT,HL("FS"),3),$E(HL("ECH"))),OBXTYP=$E($P(OBXTYP,"&",2))
+ . S OBXTYP=$P(SEGMNT,HL("FS"),3),OBXTYP=$E(OBXTYP,$F(OBXTYP,"&"))
  . S OBX2CE=""
  . S:OBXTYP="" OBXTYP=" "
@@ -144,10 +133,16 @@
  S X=$P(SEGMNT,HL("FS"),5)
  I X["\S\"!(X["\R\")!(X["\E\")!(X["\T\") D FORMAT
- I $G(RATELE),$D(RATELEKN),X[RATELEKN S X=$P(X,RATELEKN,2),RATELENM=$P(X,"-"),RATELEPI=$TR($P(X,"-",2)," ","") ;SFVAMC/DAD/9-7-2007/Comment out the quit Q  ;Patch 84
  D PAR
  F J=0:0 S J=$O(^TMP("RARPT-HL7",$J,CNT,J)) Q:'J  S X1=^(J),X=$E(X1,1,125) D PAR I $L(X1)>125 S X=$E(X1,126,999) D PAR
  I X=""!(LIN'="") S L=999 D P2
  Q
- ;
+FORMAT ; Format report text for Escape Character delimited codes.
+ S Y=X N T,Q
+ I Y["\S\" S Q=$F(Y,"\S\"),T=Q-4,X=$E(Y,1,T)_$E(HL("ECH"))_$E(Y,Q,$L(X)),Y=X
+ I Y["\R\" S Q=$F(Y,"\R\"),T=Q-4,X=$E(Y,1,T)_$E(HL("ECH"),2)_$E(Y,Q,$L(X)),Y=X
+ I Y["\E\" S Q=$F(Y,"\E\"),T=Q-4,X=$E(Y,1,T)_$E(HL("ECH"),3)_$E(Y,Q,$L(X)),Y=X
+ I Y["\T\" S Q=$F(Y,"\T\"),T=Q-4,X=$E(Y,1,T)_$E(HL("ECH"),4)_$E(Y,Q,$L(X)),Y=X
+ I X["\S\"!(X["\R\")!(X["\E\")!(X["\T\") D FORMAT
+ Q
 PAR ; Build text paragraph
  S LIN=LIN_X
@@ -167,5 +162,5 @@
  S MSA1="AA"
  Q:$E($G(HL("SAN")),1,3)'="RA-"  ; Don't allow non RA namespaced interfaces
- I $D(RAERR) S MSA1=$S($G(HL("SAN"))="RA-PSCRIBE-TCP"!$G(RATELE):"AE",1:"AR")
+ I $D(RAERR) S MSA1=$S($G(HL("SAN"))="RA-PSCRIBE-TCP":"AE",1:"AR")
  ; Added next line to support MedSpeak interface.  Must re-initialize
  ; FS and EC's before sending ACK.
@@ -176,12 +171,2 @@
  K HLRESLT D GENACK^HLMA1(HLEID,HLMTIENS,HLEIDS,HLARYTYP,HLFORMAT)
  Q
- ;
-FORMAT ; Format report text for Escape Character delimited codes.
- S Y=X N T,Q
- I Y["\S\" S Q=$F(Y,"\S\"),T=Q-4,X=$E(Y,1,T)_$E(HL("ECH"))_$E(Y,Q,$L(X)),Y=X
- I Y["\R\" S Q=$F(Y,"\R\"),T=Q-4,X=$E(Y,1,T)_$E(HL("ECH"),2)_$E(Y,Q,$L(X)),Y=X
- I Y["\E\" S Q=$F(Y,"\E\"),T=Q-4,X=$E(Y,1,T)_$E(HL("ECH"),3)_$E(Y,Q,$L(X)),Y=X
- I Y["\T\" S Q=$F(Y,"\T\"),T=Q-4,X=$E(Y,1,T)_$E(HL("ECH"),4)_$E(Y,Q,$L(X)),Y=X
- I X["\S\"!(X["\R\")!(X["\E\")!(X["\T\") D FORMAT
- Q
- ;
Index: FOIAVistA/tag/r/RADIOLOGY_NUCLEAR_MEDICINE-RA/RAMAIN.m
===================================================================
--- FOIAVistA/trunk/r/RADIOLOGY_NUCLEAR_MEDICINE-RA/RAMAIN.m	(revision 631)
+++ FOIAVistA/tag/r/RADIOLOGY_NUCLEAR_MEDICINE-RA/RAMAIN.m	(revision 636)
@@ -1,6 +1,5 @@
 RAMAIN ;HISC/FPT,GJC,CAH AISC/MJK,RMO;VMP/PW-Utility File Maintenance ;7/24/02  14:45
- ;;5.0;Radiology/Nuclear Medicine;**31,43,50,54,87**;Mar 16, 1998;Build 2
+ ;;5.0;Radiology/Nuclear Medicine;**31,43,50,54**;Mar 16, 1998
  ;
- ; 11/15/07 BAY/KAM RA*5*87 Rem Call 205080 Option File Access
 3 ;;Major AMIS Code Enter/Edit
  N RAI F RAI=1:1:5 W !?9,$P($T(REMIND+RAI),";;",2)
@@ -76,7 +75,5 @@
 10 ;;Procedure Modifiers Entry
  K DD,DO,DLAYGO,DIC,DA,DINUM,X,Y
- ;S (DIC,DLAYGO)="^RAMIS(71.2,",DIC(0)="AEMQL"
- ; 11/15/07 BAY/KAM RA*5*87 Rem Call 205080 Changed next line to set DLAYGO equal to the file number instead of the file root
- S DIC="^RAMIS(71.2,",DLAYGO=71.2,DIC(0)="AEMQL"
+ S (DIC,DLAYGO)="^RAMIS(71.2,",DIC(0)="AEMQL"
  S DIC("A")="Select Procedure Modifier: ",DIC("W")="D PROHLP^RAMAIN"
  W ! D ^DIC K DIC,DLAYGO I +Y'>0 K D,X,Y,POP,I,DDH,DG,DISYS,DUOUT Q
Index: FOIAVistA/tag/r/RADIOLOGY_NUCLEAR_MEDICINE-RA/RAO7RO1.m
===================================================================
--- FOIAVistA/trunk/r/RADIOLOGY_NUCLEAR_MEDICINE-RA/RAO7RO1.m	(revision 631)
+++ FOIAVistA/tag/r/RADIOLOGY_NUCLEAR_MEDICINE-RA/RAO7RO1.m	(revision 636)
@@ -1,4 +1,4 @@
 RAO7RO1 ;HISC/FPT-RAD/NM Error Messages ;8/28/97  14:16
- ;;5.0;Radiology/Nuclear Medicine;**2,75,86**;Mar 16, 1998;Build 7
+ ;;5.0;Radiology/Nuclear Medicine;**2,75**;Mar 16, 1998;Build 4
  ;
 EN1(RAERR) ; errors encountered with OE v3.0 back & frontdoor transmission
@@ -6,6 +6,4 @@
  I RAEMSG]"" Q RAEMSG
  Q "Error # "_RAERR_" does not exist"
- ;
- ;Note: Error code nine (9) disappears with the release of CPRS GUI V27. P86
  ;
 MSG ; error messages
Index: FOIAVistA/tag/r/RADIOLOGY_NUCLEAR_MEDICINE-RA/RAO7RON.m
===================================================================
--- FOIAVistA/trunk/r/RADIOLOGY_NUCLEAR_MEDICINE-RA/RAO7RON.m	(revision 631)
+++ FOIAVistA/tag/r/RADIOLOGY_NUCLEAR_MEDICINE-RA/RAO7RON.m	(revision 636)
@@ -1,10 +1,4 @@
 RAO7RON ;HISC/GJC- Request message from OE/RR. (frontdoor) ;2/2/98  12:34
- ;;5.0;Radiology/Nuclear Medicine;**41,75,86**;Mar 16, 1998;Build 7
- ;
- ;Supported IA #10040 reference to ^SC
- ;Supported IA #2187 reference to EN^ORERR
- ;Supported IA #10103 reference to ^XLFDT
- ;Supported IA #10141 reference to ^XPDUTL
- ;Supported IA #10106 reference to $$FMDATE^HLFNC
+ ;;5.0;Radiology/Nuclear Medicine;**41,75**;Mar 16, 1998;Build 4
  ;
  ;------------------------- Variable List -------------------------------
@@ -46,10 +40,6 @@
  S RAERR=$$EN3^RAO7VLD(44,+RAPV13) S:RAERR RAERR=3 Q:RAERR
  S RANEW(75.1,"+1,",22)=+RAPV13
- ;check the GUI version of CPRS at this facility:
- ;$$PATCH^XPDUTL("OR*3.0*243")=1 CPRS V27, else CPRS V26.
- I '$$PATCH^XPDUTL("OR*3.0*243") D  Q:RAERR  ;P86
- .I RAPV12="I",$P(^SC($P(RAPV13,U,1),0),U,3)'="W" S RAERR=9 Q
- .I RAPV12="O",$P(^SC($P(RAPV13,U,1),0),U,3)="W" S RAERR=9
- .Q
+ I RAPV12="I",$P(^SC($P(RAPV13,U,1),0),U,3)'="W" S RAERR=9 Q:RAERR
+ I RAPV12="O",$P(^SC($P(RAPV13,U,1),0),U,3)="W" S RAERR=9 Q:RAERR
  S RAPV119=$P(RADATA,RAHLFS,19)
  Q
Index: FOIAVistA/tag/r/RADIOLOGY_NUCLEAR_MEDICINE-RA/RAORD1.m
===================================================================
--- FOIAVistA/trunk/r/RADIOLOGY_NUCLEAR_MEDICINE-RA/RAORD1.m	(revision 631)
+++ FOIAVistA/tag/r/RADIOLOGY_NUCLEAR_MEDICINE-RA/RAORD1.m	(revision 636)
@@ -1,17 +1,4 @@
-RAORD1 ;HISC/CAH - AISC/RMO-Request An Exam ; 06/27/07 07:22am
- ;;5.0;Radiology/Nuclear Medicine;**10,45,41,75,86**;Mar 16, 1998;Build 7
- ;
- ;Supported IA #10035 reference to ^DPT(
- ;Supported IA #10040 reference to ^SC(
- ;Supported IA #10060 reference to ^VA(200
- ;Supported IA #2055 reference to $$EXTERNAL^DILFD
- ;Supported IA #2378 reference to ORCHK^GMRAOR
- ;Supported IA #10061 reference to ^VADPT
- ;Supported IA #10112 reference to ^VASITE
- ;Supported IA #10103 reference to ^XLFDT
- ;Supported IA #10141 reference to ^XPDUTL
- ;Supported IA #10009 reference to FILE^DICN
- ;Supported IA #10018 reference to ^DIE
- ;
+RAORD1 ;HISC/CAH - AISC/RMO-Request An Exam ; 01/21/05 11:25am
+ ;;5.0;Radiology/Nuclear Medicine;**10,45,41,75**;Mar 16, 1998;Build 4
  ;*Billing Awareness Project:
  ; RABWDX Array: ICD Diagnosis^SC^AO^IR^EC^MST^HNC
@@ -21,29 +8,15 @@
  S RAPKG="" N RAPTLKUP,RAGMTS,RACOPYOR
  G ADDORD:$D(RAVSTFLG)&($D(RALIFN))&($D(RAPIFN))
- ;
  I '$D(RAREGFLG),'$D(RAVSTFLG) N RAPTLOCK K RAWARD D  G:'RAPTLKUP Q
 PAT .S DIC="^DPT(",DIC(0)="AEMQ" W ! D ^DIC K DIC
- .I Y<0 S RAPTLKUP=0 Q 
- .S RAPTLOCK=$$LK^RAUTL19(+Y_";DPT(") G:'RAPTLOCK PAT
+ .I Y<0 S RAPTLKUP=0 Q
+ .I $$ORVR^RAORDU()'<3 D  G:'RAPTLOCK PAT
+ ..S RAPTLOCK=$$LK^RAUTL19(+Y_";DPT(")
+ ..Q
  .S (DFN,RADFN)=+Y,(VA200,RAPTLKUP)=1
  .W ! D IN5^VADPT S:VAIP(1) RAWARD=$P(VAIP(5),"^",2)
  .D ELIG^RABWORD2
  .Q
- ;
-PL ;Ask for the patient location (REQ. LOCATION file: 75.1, field: #22)
- N RACPRS27 S RACPRS27=$$PATCH^XPDUTL("OR*3.0*243")
- S DIC("A")="Patient Location: ",DIC("B")=$S($D(RAWARD)#2:RAWARD,1:"")
- S DIC="^SC(",DIC(0)="AEMQ"
- ;
- ;With the installation of RA*5.0*86 and after the implementation of
- ;CPRS v27 all active locations are eligible for selection regardless
- ;of patient type.
- ;
- ;If RAWARD is defined it is set to the name of the ward; pass either a 0
- ;or 1.
- ;Pass either a 0 or 1 as a value for RACPRS27. If 1 then CPRS GUI v27
- ;(OR*3.0*243) is installed at this facility.
- S DIC("S")="I $$SCREEN^RAORD1A("_($D(RAWARD)#2)_","_(RACPRS27)_")"
- ;
+PL S DIC("A")="Patient Location: ",DIC("B")=$S($D(RAWARD):RAWARD,1:""),DIC="^SC(",DIC(0)="AEMQ",DIC("S")="I $$SCREEN^RAORD1A()"
  D ^DIC K DIC K:'$D(RAREGFLG) RAWARD G Q:Y<0 S RALIFN=+Y
  S DIC("A")="Person Requesting Order: "
@@ -66,10 +39,13 @@
  S RADIV=$S($D(^RA(79,RADIV,0)):RADIV,1:$O(^RA(79,0)))
  S RAMDV=$TR($G(^RA(79,+RADIV,.1)),"YyNn","1100")
- D:'$D(RACAT)#2  ;if not defined, define the variable RACAT
- .I $D(RAWARD)#2 S RACAT="INPATIENT" Q
- .N Y S Y=$G(^RADPT(RADFN,0)) I Y="" S RACAT="OUTPATIENT" Q
- .S RACAT=$$EXTERNAL^DILFD(70,.04,"",$P(Y,U,4))
- .S:RACAT="" RACAT="OUTPATIENT"
+ S RACAT=$S($D(RACAT):RACAT,$D(RAWARD):"INPATIENT",$P(RAL0,"^",2)="PERSONNEL HEALTH":"EMPLOYEE",'$D(^RADPT(RADFN,0)):"OUTPATIENT",$P(^(0),"^",4)]"":$P($P(^DD(70,.04,0),$P(^RADPT(RADFN,0),"^",4)_":",2),";"),1:"OUTPATIENT")
+ I "IO"[$E(RACAT,1) D
+ .S RASTRNG=$$MATCH^RAORD1A(RACAT,RALIFN)
+ .;if necessary, change category of exam to match type of requesting
+ .;location and display msg to user
+ .S RACAT=$P(RASTRNG,"^"),RAWARD=$P(RASTRNG,"^",2)
  .Q
+ K:$D(RAWARD)&($E(RACAT,1)="O") RAWARD
+ K RASTRNG
  ; clear clin hist if:
  ;   rad backdoor, or
Index: FOIAVistA/tag/r/RADIOLOGY_NUCLEAR_MEDICINE-RA/RAORD1A.m
===================================================================
--- FOIAVistA/trunk/r/RADIOLOGY_NUCLEAR_MEDICINE-RA/RAORD1A.m	(revision 631)
+++ FOIAVistA/tag/r/RADIOLOGY_NUCLEAR_MEDICINE-RA/RAORD1A.m	(revision 636)
@@ -1,80 +1,104 @@
-RAORD1A ;HISC/FPT-Request an Exam ;7/27/07  08:00
- ;;5.0;Radiology/Nuclear Medicine;**1,86**;Mar 16, 1998;Build 7
+RAORD1A ;HISC/FPT-Request an Exam ;9/29/97  10:40
+ ;;5.0;Radiology/Nuclear Medicine;**1**;Mar 16, 1998
  ;
- ;Call to WIN^DGPMDDCF (Supported IA #1246) from the SCREENW function
- ;Supported IA #10039 reference to ^DIC(42
- ;Supported IA #10040 reference to ^SC
- ;Supported IA #10061 reference to ^VADPT
- ;Supported IA #10103 reference to ^XLFDT
+CS ; Category of exam switch. Called from [RA ORDER EXAM] input template
+ ; when requesting an exam. User can change category of exam from
+ ; (1) inpatient to outpatient and select a clinic patient location OR
+ ; (2) outpatient to inpatient and select a ward patient location.
  ;
-SCREEN(RAINPAT,RACPRS27) ; screen for active clinics/wards
+ N RAA,RAB,X,Y K DIR
+ S RAA=$S($E(RACAT)="I":"INPATIENT",1:"OUTPATIENT")
+ S RAB=$S($E(RAA)="I":"OUTPATIENT",1:"INPATIENT")
+ W ! S DIR("A",1)="CATEGORY OF EXAM is currently "_RAA
+ S DIR("A",2)=" "
+ S DIR("A")="Want to change CATEGORY OF EXAM to "_RAB
+ S DIR(0)="Y"
+ D ^DIR K DIR
+ I $D(DIRUT) S RALIFN("OUT")="" Q
+ I Y=0 S RALIFN("NO")="" Q
+REQLOC ; select patient location
+ N DIC,RAHL,RAHLWD,RASCI W !
+ASK S DIC("A")="Patient Location: ",DIC="^SC(",DIC(0)="AEMQ"
+ I $E(RAB)="O" S DIC("S")="I $$TYPE^RAORD1A(RAB,+Y),$$SCREEN^RAORD1A" I '$D(RAOERRFG) S:$P($G(^SC(+RALIFN,0)),U,3)="C" DIC("B")=$P(^SC(+RALIFN,0),U,1)
+ I $E(RAB)="I" S DIC("S")="I $$TYPE^RAORD1A(RAB,+Y),$$SCREEN^RAORD1A" I '$D(RAOERRFG) S:$P($G(^SC(+RALIFN,0)),U,3)="W" DIC("B")=$P(^SC(+RALIFN,0),U,1)
+ D ^DIC K DIC
+ I +Y'>0 S RALIFN("OUT")="" Q
+ I $E(RAB)="I" S RAHLWD=+$G(^SC(+Y,42)) I RAHLWD S RAHL=+$G(^DIC(42,RAHLWD,44)) I RAHL,RAHL'=+Y W !!,*7,"This Hospital Location points to ",$P($G(^DIC(42,+Y,0)),U,1) G ASK
+ S RALIFN=+Y,RACAT=RAB
+ Q:$D(RAOERFLG)  ;quit if REQLOC was called from REQLOC1 
+ K:$E(RAB)="O" RAWARD
+ S:$E(RAB)="I" RAWARD=$P(^SC(+Y,0),U,1)
+ Q
+SCREEN() ; screen for active clinics/wards
  ; This code is also called from RAORD1 (screen for the Patient Location
- ; prompt which is a pointer to the HOSPITAL LOCATION (#44) file.)
- ; We want to EXCLUDE from our selection the following types of
- ; hospital locations:
+ ; prompt)
+ Q:$D(^SC(+Y,"OOS")) 0 ; don't want Occasion Of Service (OOS) locations
+ N RA44 S RA44=$G(^SC(+Y,0))
+ Q:"FI"[$P(RA44,"^",3) 0 ; File areas & Imaging Types are not selectable
+ I $P(RA44,"^",3)="W" G SCREENW ; ward check
+ ; check inactivation & reactivation dates of clinic/operating
+ ; room in file #44
+ I '$D(^SC(+Y,"I")) Q 1
+ ; This Hospital Location has an "I" node.  We have to check INACTIVATE
+ ; DATE & REACTIVATE DATE fields to determine if the Hosp. Location is
+ ; active.
+ N RASCA S RASCI=$G(^SC(+Y,"I")),RASCA=+$P(RASCI,"^",2)
+ ; RASCA is the REACTIVATE DATE
+ ; Not selectable if REACTIVATE DATE is beyond DT or null (0).
+ S RASCA=$S(RASCA=0:0,RASCA>DT:0,1:RASCA)
+ I +RASCI=0 Q 1 ; no INACTIVATE DATE
+ I +RASCI>DT Q 1 ; INACTIVATE DATE exceeds today's date
+ ; Check INACTIVATE DATE against REACTIVATE DATE
+ ; if REACTIVATE DATE exists and is not after (or is equal to) the
+ ; INACTIVATE DATE the location is not active.
+ I RASCA,(+RASCI<RASCA) Q 1
+ Q 0
+SCREENW ; check currently out-of-service field of ward file (#42)
+ N D0,DGPMOS,X
+ S D0=+$G(^SC(+Y,42)) I 'D0 Q 0
+ I '$D(^DIC(42,D0,0)) Q 0
+ S:$D(RAWHEN) DGPMOS=$P(RAWHEN,".",1)
+ D WIN^DGPMDDCF
+ S X=$S(X=0:1,1:0)
+ Q X
  ;
- ;  1) Occasion of Service (OOS) locations (fld: 50.01) 'OOS' node
- ;  2) File Area ("F") or Imaging ("I") locations (fld: 2)
- ;  3) Inactivate Date (fld: 2505) 'I' node
+REQLOC1 ; Requesting Location does not go with Category of Exam
+ ; Category of Exam = Inpatient  -> Requesting Location = Ward
+ ; Category of Exam = Outpatient -> Requesting Location = Clinic
+ ; Called from [RA OERR EDIT] and [RA QUICK EXAM ORDER] input templates
+ W !!?5,*7,"When the CATEGORY OF EXAM is "_$S(RAX="I":"Inpatient",1:"Outpatient")_" the REQUESTING LOCATION",!?5,"must be a "_$S(RAX="I":"Ward",1:"Clinic")_" or OR.",!
+ W !?5,"The current REQUESTING LOCATION is ",$S($P($G(^SC(+RALIFN,0)),U,1)]"":$P($G(^SC(+RALIFN,0)),U,1),1:"Unknown"),!
+ N RAB,X,Y
+ S RAX=$S(RAX="I":"INPATIENT",1:"OUTPATIENT"),RAB=RAX,RAOERRFG=""
+ D REQLOC
+ K RAOERRFG
+ Q
+TYPE(RACAT,Y) ; Indicates whether a Hospital Location is a valid selection.
+ ; If the patient is an inpatient, all operating room location types &
+ ; all wards are valid selections.  If the patient is an outpatient, all
+ ; operating room location types & all clinics are valid selections.
+ ; Input Variables: RACAT=$S(Inpatient:"I",1:"O") "O" for outpatient
+ ; Input Variables: Y=IEN of entries in the Hospital Location file
+ ; This fuction returns 1 if valid, 0 if not valid
+ N RAX S RAX=0
+ I $E(RACAT,1)="I" D
+ . I $P(^SC(+Y,0),U,3)="W"!($P(^SC(+Y,0),U,3)="OR") S RAX=1
+ . Q
+ E  D
+ . I $P(^SC(+Y,0),U,3)="C"!($P(^SC(+Y,0),U,3)="OR") S RAX=1
+ . Q
+ Q RAX
+MATCH(RACAT,RALOC) ; Detect mismatched req loc type and cat. of exam
+ ;                 and return code for correct category of exam
+ ; Input Variable: 'RACAT' - the value for the 'Category Of Exam' field.
+ ;                 Only passed in if either 'I' or 'O'.
+ ;                 'RALOC' - The ien of the 'Requesting Location'
+ ; Output: correct category (I or O)_"^"_$S(Category='I':ward,1:"")
  ;
- ; input: RAINPAT=1 if the patient is an inpatient located on a ward, else 0.
- ;        RACPRS27=1 if the environment is running CPRS GUI v27, else 0.
- ;
- Q:$D(^SC(+Y,"OOS"))#2 0 ; #1
- N RA44 S RA44=$G(^SC(+Y,0)),RA44(42)=$P($G(^SC(+Y,42)),U)
- Q:"^F^I^"[(U_$P(RA44,U,3)_U) 0 ; #2
- ;
- ; if the hospital location is defined as a ward set RAWARD to 1, else 0
- N RAWARD S RAWARD=0
- ;check the pointer to the WARD LOCATION file.
- I RA44(42)>0 D  Q:RAWARD=-1 0
- .;Error; the HOSPITAL LOCATION cannot be of TYPE 'Clinic' & point to a ward
- .I $P(RA44,U,3)="C" S RAWARD=-1 Q
- .;Error; bad pointers between files 42 & 44
- .I $P($G(^DIC(42,RA44(42),44)),U)'=+Y S RAWARD=-1 Q
- .;ok, set ward flag...
- .S RAWARD=1
- .Q
- ;
- ; 1) if the hospital location is a ward check if we should screen by ward
- ; 2) the hosp location=ward, facility is running v26, and we have an
- ;    outpatient quit zero (default of the $S)
- I RAWARD  Q $S(RACPRS27!RAINPAT:$$SCREENW(+Y),1:0)
- ;
- ; if the hospital location is a clinic, we have an inpatient, and the
- ; facility is not running CPRS v27 return 0
- I 'RACPRS27,(RAINPAT) Q 0
- ;
- ; Check INACTIVATE DATE against REACTIVATE DATE
- ; inactivate date = reactivate date (allow)
- ; inactivate date > reactivate date (disallow)
- ; inactivate date < reactivate date (allow)
- ;
- N RASCA,RASCI,RASCINDE S RASCINDE=$G(^SC(+Y,"I"))
- S RASCI=+$P(RASCINDE,U),RASCA=+$P(RASCINDE,U,2)
- ;
- Q $S(RASCI'>0:1,RASCI>DT:1,1:RASCI'>RASCA)
- ;
-SCREENW(Y) ; check the out-of-service field of the WARD LOCATION (#42) record.
- ;input Y: ien of the HOSPITAL LOCATION record
- ; RAWHEN: DATE DESIRED (Not guaranteed) (file: 75.1, fld: 21) optional
- ;output : '0' if not valid, else '1' if valid 
- N D0,DGPMOS,X
- S D0=+$G(^SC(Y,42))
- Q:'D0 0
- Q:'($D(^DIC(42,D0,0))#2) 0
- ;
- ;WIN^DGPMDDCF (Supported IA #1246) Is the ward active?
- ; Input
- ;  D0 "Dee zero" (req): IEN of WARD LOCATION file.  
- ;  DGPMOS (opt): defaults to DT. Is the ward in service on this date?  
- ; Output
- ;  X: 1 if out of service, 0 if in service, or -1 if input variables
- ;     not defined properly. Be careful; note the difference in their
- ;     boolean definition ('0'=success) and ours ('0'=failure)
- ;
- S:$D(RAWHEN)#2 DGPMOS=$P(RAWHEN,".",1)
- D WIN^DGPMDDCF
- Q 'X  ;alter 'X' (the WIN^DGPMDDCF output value) to meet our ($$SCREENW) output definition
+ N RA44 S RA44=$G(^SC(+RALOC,0))
+ I $E(RACAT,1)'="I",$E(RACAT,1)'="O" Q RACAT
+ I $E(RACAT,1)="O",$P(RA44,U,3)'="C",($P(RA44,U,3)'="OR") S RACAT="INPATIENT"
+ I $E(RACAT,1)="I",$P(RA44,U,3)'="W",($P(RA44,U,3)'="OR") S RACAT="OUTPATIENT"
+ Q RACAT_"^"_$S($E(RACAT,1)="I":$P(RA44,"^"),1:"")
  ;
 PREG(RADFN,RADT) ; Subroutine will display the pregnancy prompt to the
@@ -105,3 +129,2 @@
  F  S RACNT=$O(RAMOD(RACNT),-1) Q:RACNT=""!(X=0)  S:RAMOD(RACNT)=Y X=0
  Q X
- ;
Index: FOIAVistA/tag/r/RADIOLOGY_NUCLEAR_MEDICINE-RA/RARTR.m
===================================================================
--- FOIAVistA/trunk/r/RADIOLOGY_NUCLEAR_MEDICINE-RA/RARTR.m	(revision 631)
+++ FOIAVistA/tag/r/RADIOLOGY_NUCLEAR_MEDICINE-RA/RARTR.m	(revision 636)
@@ -1,4 +1,4 @@
 RARTR ;HISC/CAH COLUMBIA/REB AISC/MJK,RMO-Queue/print Reports ;11/27/98  09:05
- ;;5.0;Radiology/Nuclear Medicine;**5,13,16,27,43,55,75,92**;Mar 16, 1998;Build 4
+ ;;5.0;Radiology/Nuclear Medicine;**5,13,16,27,43,55,75**;Mar 16, 1998;Build 4
 PRT ; Begin print/build of e-mail message
  ;
@@ -132,10 +132,5 @@
  K RARPT,RAHDFM,RAFTFM,RAV,RAIOF,RABTCH,RAOOUT,RAPIR,RAPIS,VAERR,Z
  ; K RASTRSK S RAFFLF=RAORIOF K RAORIOF,RAFFLF,RAERRFLG
- ; 05/15/08 BAY/KAM Patch RA*5*92 Added Conditional Kill to next line
- ; to support an AMIE interface (IA 708)
- K RASTRSK,RAORIOF,RAFFLF,RAERRFLG K:'($D(RAMIE)#2) DFN
- ;the next kill line corrects the CPRS V27 report display issue when repeated
- ;on same patient P92
- K %,DIW,DIWF,DIWI,DIWL,DIWT,DIWTC,DIWX,RAACNT,RADUPHX,RANUM,RAREZON,RAST
+ K RASTRSK,RAORIOF,RAFFLF,RAERRFLG
  Q
 Q ; Queue the report
Index: FOIAVistA/tag/r/RADIOLOGY_NUCLEAR_MEDICINE-RA/RARTR0.m
===================================================================
--- FOIAVistA/trunk/r/RADIOLOGY_NUCLEAR_MEDICINE-RA/RARTR0.m	(revision 631)
+++ FOIAVistA/tag/r/RADIOLOGY_NUCLEAR_MEDICINE-RA/RARTR0.m	(revision 636)
@@ -1,23 +1,10 @@
 RARTR0 ;HISC/GJC-Queue/Print Radiology Rpts utility routine. ;1/8/97  08:07
- ;;5.0;Radiology/Nuclear Medicine;**8,26,74,84**;Mar 16, 1998;Build 13
+ ;;5.0;Radiology/Nuclear Medicine;**8,26,74**;Mar 16, 1998;Build 2
  ; 06/28/2006 BAY/KAM Remedy Call 146291 - Change Patient Age to DOB
- ;
- ;Integration Agreements
- ;----------------------
- ;DT^DILF(2054); GETS^DIQ(2056); $$FMTE^XLFDT(10103); $$UP^XLFSTR(10104)
- ;NEW PERSON file read w/FM (10060)
- ;
-EN1 ; Called from RARTR ;P84 GETS^DIQ added... 
+EN1 ; Called from RARTR
  S RARPT(0)=$G(^RARPT(+$G(RARPT),0)) Q:RARPT(0)']""
  S RARPT(10)=$P(RARPT(0),"^",10)
  S RAVERF=+$P(RARPT(0),U,9),RAPVERF=+$P(RARPT(0),U,13)
- K RAPIR,RAPIS S RAPIR=+$P(RALB,"^",12),RAPIS=+$P(RALB,"^",15)
- ;format of the RAPIR/RAPIS arrays: P84 logic
- ;RAPI*=IEN file 200
- ;RAPI*(200,RAPI*,.01)= NAME (required)
- ;RAPI*(200,RAPI*,20.2) = SIGNATURE BLOCK PRINTED NAME (if any)
- ;RAPI*(200,RAPI*,20.3) = SIGNATURE BLOCK TITLE (if any)
- I RAPIR D GETS^DIQ(200,RAPIR,".01;20.2;20.3","","RAPIR") S RAPIR("IENS")=RAPIR_","
- I RAPIS D GETS^DIQ(200,RAPIS,".01;20.2;20.3","","RAPIS") S RAPIS("IENS")=RAPIS_","
+ S RAPIR=+$P(RALB,"^",12),RAPIS=+$P(RALB,"^",15)
  S RAWHOVER=+$P(RARPT(0),"^",17)
  I RAVERF,((RAPIR=RAVERF)!(RAPIS=RAVERF)) D
@@ -25,17 +12,13 @@
  . Q
  I RAPIS D  Q:$D(RAOOUT)
- . ;get signature block name if defined
- . S RALBS=$E(RAPIS(200,RAPIS("IENS"),20.2),1,25)
- . S:RALBS="" RALBS=$E(RAPIS(200,RAPIS("IENS"),.01),1,25) ;default to NAME
- . ;
- . ;get signature block title if defined
- . S RALBST=$G(RAPIS(200,RAPIS("IENS"),20.3)) ; max: 50 chars
- . S:RALBST="" RALBST=$$TITLE^RARTR0(RAPIS)
- . ;
+ . S RALBS=$E($P($G(^VA(200,RAPIS,20)),"^",2),1,25)
+ . S:RALBS']"" RALBS=$E($P($G(VA(200,RAPIS,0)),"^"),1,25)
+ . S RALBST=$P($G(^VA(200,RAPIS,20)),"^",3) ; max: 50 chars
+ . I RALBST']"" S RALBST=$$TITLE^RARTR0(RAPIS)
  . I '$D(RAUTOE) D:($Y+RAFOOT+4)>IOSL HANG^RARTR2 Q:$D(RAOOUT)
  . I '$D(RAUTOE) D HD^RARTR:($Y+RAFOOT+4)>IOSL
  . I '$D(RAUTOE) D
- .. W !,"Primary Interpreting Staff:",!?2,$S(RALBS]"":RALBS,1:"Unknown")
- .. W:$L(RALBST) ", "_$E(RALBST,1,((IOM-$X)-16))
+ .. W !,"Primary Interpreting Staff:"
+ .. W !?2,$S(RALBS]"":RALBS,1:"Unknown"),", ",$E(RALBST,1,((IOM-$X)-16))
  .. ; The '-16' above is derived from $L("(Pre-Verifier)")+1 FORMATTING
  .. Q
@@ -43,8 +26,8 @@
  .. S ^TMP($J,"RA AUTOE",$$INCR^RAUTL4(RAACNT))="Primary Interpreting Staff:"
  .. S ^TMP($J,"RA AUTOE",$$INCR^RAUTL4(RAACNT))="  "_$S(RALBS]"":RALBS,1:"Unknown")
- .. Q:'$L(RALBST)  N RALEN S RALEN=$L(^TMP($J,"RA AUTOE",RAACNT))
+ .. N RALEN S RALEN=$L(^TMP($J,"RA AUTOE",RAACNT))
  .. S ^TMP($J,"RA AUTOE",RAACNT)=^TMP($J,"RA AUTOE",RAACNT)_", "_$E(RALBST,1,((80-RALEN)-16))
  .. Q
- . I $D(RAVERFND)&(RAPIS=RAVERF),(RAPIS(200,RAPIS("IENS"),.01)'="RADIOLOGY,OUTSIDE SERVICE") D
+ . I $D(RAVERFND)&(RAPIS=RAVERF) D
  .. I $G(RARPT(10))']"",('$D(RAUTOE)) D  Q
  ... W:RAWHOVER=RAPIS !?10,"(Verifier, no e-sig)"
@@ -62,24 +45,18 @@
  . Q
  D SECSTF^RARTR1 Q:$D(RAOOUT)  ; Print secondary interp'ting staff now
- ;now for primary resident definitions...
  I RAPIR D  Q:$D(RAOOUT)
- . ;get signature block name if defined
- . S RALBR=$E(RAPIR(200,RAPIR("IENS"),20.2),1,25)
- . S:RALBR="" RALBR=$E(RAPIR(200,RAPIR("IENS"),.01),1,25) ;default to NAME
- . ;
- . ;get signature block title if defined
- . S RALBRT=$G(RAPIR(200,RAPIR("IENS"),20.3)) ; max: 50 chars
- . S:RALBRT="" RALBRT=$$TITLE^RARTR0(RAPIR)
- . ;
+ . S RALBR=$E($P($G(^VA(200,RAPIR,20)),"^",2),1,25)
+ . S:RALBR']"" RALBR=$E($P($G(VA(200,RAPIR,0)),"^"),1,25)
+ . S RALBRT=$P($G(^VA(200,RAPIR,20)),"^",3) ; max: 50 chars
+ . I RALBRT']"" S RALBRT=$$TITLE^RARTR0(RAPIR)
  . I '$D(RAUTOE) D:($Y+RAFOOT+4)>IOSL HANG^RARTR2 Q:$D(RAOOUT)
  . I '$D(RAUTOE) D HD^RARTR:($Y+RAFOOT+4)>IOSL
- . I '$D(RAUTOE) D
- .. W !,"Primary Interpreting Resident:",!?2,$S(RALBR]"":RALBR,1:"Unknown")
- .. W:$L(RALBRT) ", "_$E(RALBRT,1,((IOM-$X)-16))
- .. Q
+ . W:'$D(RAUTOE) !,"Primary Interpreting Resident:"
+ . W:'$D(RAUTOE) !?2,$S(RALBR]"":RALBR,1:"Unknown")_", ",$E(RALBRT,1,((IOM-$X)-16))
+ . ; The '-16' above is derived from $L("(Pre-Verifier)")+1 FORMATTING
  . I $D(RAUTOE) D
  .. S ^TMP($J,"RA AUTOE",$$INCR^RAUTL4(RAACNT))="Primary Interpreting Resident:"
  .. S ^TMP($J,"RA AUTOE",$$INCR^RAUTL4(RAACNT))="  "_$S(RALBR]"":RALBR,1:"Unknown")
- .. Q:'$L(RALBRT)  N RALEN S RALEN=$L(^TMP($J,"RA AUTOE",RAACNT))
+ .. N RALEN S RALEN=$L(^TMP($J,"RA AUTOE",RAACNT))
  .. S ^TMP($J,"RA AUTOE",RAACNT)=^TMP($J,"RA AUTOE",RAACNT)_", "_$E(RALBRT,1,((80-RALEN)-16))
  .. Q
@@ -100,13 +77,14 @@
  . Q
  D SECRES^RARTR1 ; Print out secondary interp'ting resident now
- K RAPIR,RAPIS ;P84 kills added
  Q
- ;
-TITLE(X) ;Return the radiology classification in lieu of the signature block title
+TITLE(X) ; Determine an individuals title
  ; 'X' is the IEN of the Primary Interpreting Resident i.e, ^DD(70.03,12
  ; -OR-
  ; 'X' is the IEN of the Primary Interpreting Staff i.e, ^DD(70.03,15
- Q $S($D(^VA(200,"ARC","R",X)):"Resident Physician",$D(^VA(200,"ARC","S",X)):"Staff Physician",1:"")
- ; 
+ N Y
+ I $D(^VA(200,"ARC","R",X)) S Y="Resident Physician" Q Y
+ I $D(^VA(200,"ARC","S",X)) S Y="Staff Physician" Q Y
+ S Y=""
+ Q Y
 HEAD ; Set up header info for e-mail message (called from INIT^RARTR)
  ; 06/28/2006 BAY/KAM Remedy Call 146291 Change Patient Age to DOB
